/*  $Id: RunnableConcurrence.java 1335 2012-08-25 13:27:49Z sdevaux $
 *
 * Tabs = 4 chars
 * copyright (C) 2002-2012 Sebastien Devaux
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 *
 *              Sebastien Devaux <sebastien.devaux@laposte.net>
 */
package net.eduvax.util;

import java.util.Vector;


	/** 
	 * Gestion de l'execution d'un lot de runnable en parallèle.
     * @djin.link use,EThread
     */ 
	public class RunnableConcurrence extends ARunnableSet
    {
		/** Creer nouveau lanceur parallelisé 
		 * @param name nom du lot
		 * @param join préciser s'il faudra attendre la fin de chaque 
         * Runnable
         */
		public RunnableConcurrence(String name,boolean join)
		{
			_name=name;
			_join=join;
		}
		/** mise en oeuvre Runnable */
		@Override public void run() {
		    Vector<Runnable> runList=getRunList();
		    EThread[] thList=new EThread[runList.size()];
            for (int i=0;i<thList.length;i++) {
            	Runnable toRun=runList.elementAt(i);
			    String name=""+getClass()+"/"+_name+":"+i
                        +"/"+toRun.getClass();
                thList[i]=new EThread(name,toRun);
                thList[i].start();
            }
			if (_join)
			{
	            for (int i=0;i<thList.length;i++) {
					try {
						thList[i].join();
					} 
					catch (InterruptedException e) {
						App.get().log().warn("Wait for end of "
									+thList[i].getName()+" interrupted.");
					}
				}
			}
		}
		/** nom du lot */
		private String _name;
		/** si true : attendre la fin de tous les processus. */
		private boolean _join;
	}

